package it.unicam.cs.asdl1819.project2;

/**
 * Interfaccia che raggruppa le due operazioni di lettura e scrittura di
 * priorità. Qualsiasi classe i cui elementi devono essere inseriti in una
 * {@code MinPriorityQueue} deve implementare questa interfaccia.
 * 
 * @author Luca Tesei
 *
 */
public interface PriorityQueueElement {

    /**
     * Restituisce la priorità corrente.
     * 
     * @return la priorità corrente
     */
    public double getPriority();

    /**
     * Assegna una nuova priorità.
     * 
     * @param priority
     *                     la priorità nuova da assegnare
     */
    void setPriority(double priority);
}
